world
	hub="ATPDevelopment.Fallout"
	name="Falldown"
	turf=/turf/back
var/level=1
atom/icon='icons.dmi'
var
	list/players=list()
	list/scores=list()
	list/names=list()
	mob/host
	Play="A"
	started
turf
	back
		icon_state="back"
		New()
			dir=pick(1,2,4,8)
	Enter(mob/M)
		if(ismob(M))
			if(M.client.playing)
				var/obj/Parachute/P=locate() in src
				var/obj/Bomb/B=locate() in src
				var/obj/Glue/G=locate() in src
				if(P)
					.=1
					spawn(1) M.Parachute()
					del P
				if(B)
					.=1
					del B
					spawn(1) new /obj/bomb(src)
				if(G)
					.=1
					del G
					new /obj/glue(src)
					M.Glued()
				else
					.=..()
		else
			.=..()
obj
	block
		icon_state="block"
		density=1
	Parachute
		density=1
		icon_state="Parachute"
		New()
			while(src)
				step(src,pick(EAST,WEST))
				sleep(3)

	parachute
		icon_state="parachute"
	Bomb
		icon_state="Bomb"
		density=1
		New()
			while(src)
				step(src,pick(EAST,WEST))
				sleep(3)
	bomb
		icon_state="bomb"
		density=1
		New(Loc)
			loc=Loc
			while(src)
				step(src,SOUTH)
				sleep(2)
		Bump(atom/A)
			if(isobj(A))
				for(var/turf/T in block(locate(A.x-1,A.y-1,A.z),locate(A.x+1,A.y+1,A.z)))
					new /obj/flame(T)
			del src
	flame
		icon_state="explode"
		New(loc)
			src.loc=loc
			for(var/obj/O in src.loc)
				if(O!=src) del O
			spawn(6)
				del src
	Glue
		density=1
		icon_state="Glue"
		New()
			while(src)
				step(src,pick(EAST,WEST))
				sleep(3)
	glue
		icon_state="glue"
		New(loc)
			src.loc=loc
			spawn(50) del src

mob
	var/points=0
	var/delay=2
	var/glued=0
	density=1
	Login()
		loc=locate(5,world.maxy,level)
	Bump(atom/A)
		if(Play=="P"&&isobj(A))
			src.points-=10
		else if(Play=="S"&&isobj(A)&&dir==SOUTH)
			src.icon_state=""
			src.density=0
			src.client.playing=0
			var/Win=1
			for(var/mob/M in players)
				if(M!=src)
					if(M.client.playing)
						Win=0
			if(!Win)
				world<<"[src] has been eliminated!"
			if(Win)
				world<<"[src] has survived the longest! [src] wins this round! Rebooting..."
				sleep(30)
				world.Reboot()
	proc/Points()
		src.client.count=1
		while(src.client.count)
			src.points+=5
			sleep(10)
	proc/Fall()
		while(src.client.playing)
			if(!glued)
				step(src,SOUTH)
			sleep(src.delay)
	proc/Parachute()
		var/obj/parachute/P=new
		P.pixel_y=31
		src.overlays+=P
		src.delay=5
		sleep(100)
		src.overlays=list()
		src.delay=2
	proc/Glued()
		src.glued=1
		sleep(50)
		src.glued=0
	Stat()
		if(Play=="P")
			statpanel("Points")
			for(var/mob/M in players)
				stat("[M]","[M.points]")
		if(Play=="S")
			statpanel("Survival")
			for(var/mob/M in players)
				if(M.client.playing)
					stat("[M]","Falling")
				if(!M.client.playing)
					stat("[M]","Eliminated")
proc
	UpdateZ()
		level++
		if(level>4)
			level=1
		for(var/mob/M in world)
			M.loc=locate(M.x,M.y,level)
		world << "Level: [level]"
client
	var
		playing
		Choosing
		Choosing2
		count
	view="12x16"
	New()
		var/icon/I1=icon('icons.dmi',"Parachute")
		var/icon/I2=icon('icons.dmi',"Bomb")
		var/icon/I3=icon('icons.dmi',"Glue")
		var/icon/I4=icon('icons.dmi',"mob")
		src<<browse_rsc(I1,"Parachute.png")
		src<<browse_rsc(I2,"Bomb.png")
		src<<browse_rsc(I3,"Glue.png")
		src<<browse_rsc(I4,"Mob.png")
		src<<browse(Info)
		..()
		world<<"[src] is here!"
	West()
		if(!playing&&players.len<3&&!started)
			playing=1
			players+=src.mob
			mob.icon_state="mob"
			if(players.len==2)
				var/icon/I=new
				I=icon(src.mob.icon,src.mob.icon_state)
				I.SwapColor(rgb(0,0,204),rgb(204,0,0))
				I.SwapColor(rgb(51,51,255),rgb(255,51,51))
				I.SwapColor(rgb(0,0,255),rgb(255,0,0))
				src.mob.icon=I
				mob.x++
			else if(players.len==3)
				var/icon/I=new
				I=icon(src.mob.icon,src.mob.icon_state)
				I.SwapColor(rgb(0,0,204),rgb(0,204,0))
				I.SwapColor(rgb(51,51,255),rgb(51,255,51))
				I.SwapColor(rgb(0,0,255),rgb(0,255,0))
				src.mob.icon=I
				mob.x+=2
		if(!host)
			host=src.mob
			world<<"[src] is choosing the mode!"
			src<<"Choose mode. Left for Survival, Right for Point"
			Choosing=1
		else if(Choosing)
			world<<"The mode of play is: Survival! [src] is Picking Map..."
			Choosing=0
			Choosing2=1
			Play="S"
		else if(Choosing2)
			UpdateZ()
		else if(!started&&host==src.mob)
			world<<"The Game Is Starting!"
			Start()
		else if(playing&&started&&!mob.glued)
			..()
	East()
		if(Choosing)
			world<<"The mode of play is: Point! [src] is Picking Map..."
			Choosing=0
			Choosing2=1
			Play="P"
		else if(Choosing2)
			Choosing2=0
			world<<"The map level has been set to [level]."
		else if(playing&&started&&!mob.glued)
			..()
	North()
	South()
	Northeast()
	Northwest()
	Southeast()
	Southwest()
proc
	Start()
		started=1
		sleep(10)
		world<<"3!"
		sleep(10)
		world<<"2!"
		sleep(10)
		world<<"1!"
		sleep(10)
		world<<"GO!"
		for(var/mob/M in world)
			if(Play=="P")
				if(M.client.playing)
					spawn(1) M.Points()
			spawn(1) M.Fall()
turf/StopPlay
	Entered(mob/M)
		if(ismob(M))
			if(M.client.count)
				M.client.count=0
				names+="[M.name]"
				scores+=M.points
				M.density=0
				if(scores.len>1)
					if(scores[scores.len-1]<M.points)
						scores.Swap(scores.len,scores.len-1)
		var/End=1
		for(var/mob/M2 in players)
			if(M2.client.count)
				End=0
		if(End)
			for(var/I=1 to scores.len)
				world << "In [I]\th place with [scores[I]] points: [names[I]]"
			world<<"Rebooting..."
			sleep(10)
			world.Reboot()

#define DEBUG

mob/verb/Say(T as text)
	set hidden=1
	world<<"[src]: [html_encode(copytext(T,1,501))]"

client/command_text="say "

var/const/Info={"
		<html><head></head><body bgcolor=#999999><center>
		<font size=7><img src="Mob.png">Fallout<img src="Mob.png"></font><br>
		by ATP Development</center><br><br>
		Welcome to <b>Fallout</b>! The point of this game is to reach the bottom without
		hitting any blocks! Use the left and right arrow keys to move left and right and
		fall in between the gaps of the blocks.<br><br>There are two modes of play. Survival,
		and point. In survival, if you hit a block you are eliminated from the game. The
		person who lasts the longest wins that round. In point, you will gain points as you
		fall. Everytime you hit a block, you will lose points. The person with the most points
		wins. <br><br>
		To join, use the left key. If you are the first to join, use the right key or
		left key to chose mode of play (point or survival, respectively). Press the left key to
		cycle through the available maps. Press the right key to confirm your choice.
		Once another player (or 2 others) have joined, press the left key to start the game. A
		countdown will show up, and then you will all begin	to fall. Enjoy!
		<br><br><b>Powerups</b>: <br><img src="Bomb.png"><b>Bomb</b>: If you fall
		into this powerup, a bomb will fall. When the bomb hits a block, it will destroy that
		block, as well as the surrounding blocks. <br><img src="Parachute.png"><b>Parachute</b>:
		If you fall into this powerup, a parachute will attach to your character's feet. This
		will slow down the speed of your descent for 10 seconds.<br><img src="Glue.png">
		<b>Glue</b>: This powerup will completely stop your decent for 5 seconds. This allows
		you to gain more points in the point mode. In survival mode, this helps by giving you
		a break while your opponent(s) continue to fall. "}

mob/verb/showcode(msg as message)
	world<<browse("<pre>[html_encode(msg)]</pre>","window=new")
